import { NodeAttribute, QueryGraphEdgeHandle, QueryGraphNodes } from './graphology';
import { InputNodeType } from './logic/general';
import { QueryElementTypes, SchemaReactflowNode } from './reactflow';

export * from './BackendQueryFormat';
export * from './graphology';
export * from './logic';
export * from './reactflow';

type ExtraProps = { extra?: string; separator?: string };
export function toHandleId(handleData: QueryGraphEdgeHandle, separator: string = '__'): string {
  // if (!extra) extra = '';
  if (!separator) separator = '__';
  return [handleData.nodeId, handleData.nodeType, handleData.nodeName, handleData.attributeName, handleData.attributeType].join(separator);
}
// export function getHandleIdFromGraphology(node: QueryGraphNodes, attribute: NodeAttribute, options: ExtraProps = {}): string {
//   return toHandleId(node.id || '', node.name, node.type, attribute.name, attribute.type, options);
// }
export function handleDataFromReactflowToId(node: SchemaReactflowNode, attribute: NodeAttribute, options: ExtraProps = {}): string {
  if (!node.data.name) throw Error('node.data is not defined');
  return toHandleId({
    nodeId: node.id,
    nodeName: node.data.name,
    nodeType: node.type as QueryElementTypes,
    attributeName: attribute.handleData.attributeName,
    attributeType: attribute.handleData.attributeType,
  });
}
export function toHandleData(handleId: string, separator: string = '__'): QueryGraphEdgeHandle {
  let [nodeId, nodeType, nodeName, attributeName, attributeType] = handleId.split(separator);
  const _nodeType = nodeType as QueryElementTypes;
  const _attributeType = attributeType as InputNodeType;
  return { nodeId, nodeType: _nodeType, nodeName, attributeName, attributeType: _attributeType };
}
