import {
  GeneralDescription,
  InputNodeType,
  MathFunctionTypes,
  MathFilterTypes,
  StringFilterTypes,
  StringFunctionTypes,
  MathAggregationTypes,
} from './general';
import { MathAggregations } from './mathAggregations';
import { MathFilters } from './mathFilters';
import { MathFunctions } from './mathFunctions';
import { StringFilters } from './stringFilters';
import { StringFunctions } from './stringFunctions';

export type AllLogicTypes = MathFilterTypes | MathFunctionTypes | MathAggregationTypes | StringFilterTypes | StringFunctionTypes;
export type AllLogicDescriptions = GeneralDescription<AllLogicTypes>;

export const AllLogicMap: Record<string, AllLogicDescriptions> = {
  ...Object.fromEntries(Object.values(MathFilters).map((x) => [x.key, x])),
  ...Object.fromEntries(Object.values(MathFunctions).map((x) => [x.key, x])),
  ...Object.fromEntries(Object.values(MathAggregations).map((x) => [x.key, x])),
  ...Object.fromEntries(Object.values(StringFilters).map((x) => [x.key, x])),
  ...Object.fromEntries(Object.values(StringFunctions).map((x) => [x.key, x])),
};

export * from './graphFunctions';
export * from './mathFunctions';
export * from './mathFilters';
export * from './stringFunctions';
export * from './stringFilters';
