/**
 * This program has been developed by students from the bachelor Computer Science at
 * Utrecht University within the Software Project course.
 * © Copyright Utrecht University (Department of Information and Computing Sciences)
 */

import { Position } from 'reactflow';
import { GeneralDescription, MathFunctionTypes } from './general';

export const MathFunctions: Record<MathFunctionTypes, GeneralDescription<MathFunctionTypes>> = {
  [MathFunctionTypes.ADD]: {
    key: 'mathFunctionAdd',
    name: 'Add',
    type: MathFunctionTypes.ADD,
    description: 'Add two values',
    numInputs: 2,
    inputs: [
      { name: '1', type: 'float', default: 0 },
      { name: '2', type: 'float', default: 0 },
    ],
    output: { name: '+', type: 'float' },
    logic: ['+', '@1', '@2'],
  },
  [MathFunctionTypes.SUBTRACT]: {
    key: 'mathFunctionSubtract',
    name: 'Subtract',
    type: MathFunctionTypes.SUBTRACT,
    description: 'Subtract two values',
    numInputs: 2,
    inputs: [
      { name: '1', type: 'float', default: 0 },
      { name: '2', type: 'float', default: 0 },
    ],
    output: { name: '-', type: 'float' },
    logic: ['-', '@1', '@2'],
  },
  [MathFunctionTypes.MULTIPLY]: {
    key: 'mathFunctionMultiply',
    name: 'Multiply',
    type: MathFunctionTypes.MULTIPLY,
    description: 'Multiply two values',
    numInputs: 2,
    inputs: [
      { name: '1', type: 'float', default: 0 },
      { name: '2', type: 'float', default: 0 },
    ],
    output: { name: '*', type: 'float' },
    logic: ['*', '@1', '@2'],
  },
  [MathFunctionTypes.DIVIDE]: {
    key: 'mathFunctionDivide',
    name: 'Divide',
    type: MathFunctionTypes.DIVIDE,
    description: 'Divide two values',

    numInputs: 2,
    inputs: [
      { name: '1', type: 'float', default: 0 },
      { name: '2', type: 'float', default: 0 },
    ],
    output: { name: '/', type: 'float' },
    logic: ['/', '@1', '@2'],
  },
};

/** All available functions in the function bar. */
export const MathFunctionArray: Array<GeneralDescription<MathFunctionTypes>> = Object.values(MathFunctions);
