import React from 'react';
import {
  colorPaletteConfigSlice,
  querybuilderSlice,
  setQuerybuilderNodes,
  setSchema,
  store,
} from '@graphpolaris/shared/lib/data-access/store';
import { GraphPolarisThemeProvider } from '@graphpolaris/shared/lib/data-access/theme';
import { configureStore } from '@reduxjs/toolkit';
import { Meta } from '@storybook/react';
import { Provider } from 'react-redux';
import QueryBuilder from '../querybuilder';
import { QueryElementTypes, QueryMultiGraphology, toHandleId } from '../../model';

const Component: Meta<typeof QueryBuilder> = {
  component: QueryBuilder,
  title: 'QueryBuilder/Panel/SingleEntity',
  decorators: [
    (story) => (
      <Provider store={store}>
        <GraphPolarisThemeProvider>
          <div
            style={{
              width: '100%',
              height: '95vh',
            }}
          >
            {story()}
          </div>
        </GraphPolarisThemeProvider>
      </Provider>
    ),
  ],
};

export const SingleEntity = {
  args: {},
  play: async () => {
    const graph = new QueryMultiGraphology();
    graph.addPill2Graphology({
      type: QueryElementTypes.Entity,
      x: 100,
      y: 100,
      name: 'Entity Pill',
    });
    store.dispatch(setQuerybuilderNodes(graph.export()));
  },
};

export default Component;
