/**
 * This program has been developed by a student from the bachelor Information Science at
 * Utrecht University within the Research Project course.
 * © Copyright Utrecht University (Department of Information and Computing Sciences)
 */

import { PickingInfo } from 'deck.gl/typed';

export const getTooltip = ({ object }: PickingInfo): any => {
  const ret = {
    style: {
      backgroundColor: 'white',
      color: 'black',
      fontSize: '15px',
      fontFamily: 'Calibri, monospace',
      border: '1px solid gray',
    },
  };
  if (object && object.hasOwnProperty('type')) {
    const { id, geometry, properties } = object;
    return {
      ...ret,
      html: `
        <div>
          <h3>Cluster id: ${id}</h3>
          <p>Point count: ${properties.point_count}</p>
          <p>Nodes: ${properties.ids.slice(0, 5)}...</p>
        </div>
      `,
    };
  } else if (object && object.hasOwnProperty('geometry')) {
    const { geometry, properties } = object;
    return {
      ...ret,
      html: `
        <div>
          <h3>Airport: ${properties.id}</h3>
          <p>City: ${properties.attributes.city}</p>
        </div>
      `,
    };
  } else if (object && object.hasOwnProperty('attributes') && object.attributes.hasOwnProperty('locations')) {
    const { id, attributes } = object;
    return {
      ...ret,
      html: `
        <div>
          <h3>${id}</h3>
          <p>Location: ${attributes.coordinates}</p>
          <p>Nodes: ${attributes.locations}</p>

        </div>
      `,
    };
  } else if (object && object.hasOwnProperty('id') && object.attributes.hasOwnProperty('prediction')) {
    const { from, to, count, attributes } = object;
    return {
      ...ret,
      html: `
        <div>
          <h3>${from}-${to}</h3>
          <p>Flight count: ${count}</p>
          <p>Predicted passengers: ${attributes.prediction}</p>

        </div>
      `,
    };
  } else if (object && object.attributes.hasOwnProperty('airport')) {
    const { id, attributes } = object;
    return {
      ...ret,
      html: `
        <div>
          <h3>Airport: ${id}</h3>
          <p>Location: ${attributes.coordinates}</p>
          <p>City: ${attributes.city}</p>
        </div>
      `,
    };
  } else {
    return;
  }
};
